
#user  nobody;
worker_processes  1;

error_log  logs/error.log;
#error_log   logs/debug.log debug;
#error_log  logs/error.log  notice;
#error_log  logs/error.log  info;

#pid        logs/nginx.pid;


events {
    worker_connections  1024;
}


http {
    include       mime.types;
    default_type  application/octet-stream;

    #log_format  main  '$remote_addr - $remote_user [$time_local] "$request" '
    #                  '$status $body_bytes_sent "$http_referer" '
    #                  '"$http_user_agent" "$http_x_forwarded_for"';

    #access_log  logs/access.log  main;

    sendfile        on;
    #tcp_nopush     on;

    #keepalive_timeout  0;
    keepalive_timeout  60;

    #gzip  on;

    server {
        listen    80;
        server_name  localhost;


#allow publish 127.0.0.1;
#deny publish all;
#allow play 192.168.0.0/24;
#deny play all;


        location /control {
          rtmp_control all;
        }

        #charset koi8-r;

        #access_log  logs/host.access.log  main;

        # rtmp server status: [!!!]
        location /stat {
            rtmp_stat all;
            rtmp_stat_stylesheet stat.xsl;
        }

        location /stat.xsl {
            root html;
        }


        
        location / {
            root   html;
            index  index.html index.htm;
        }

        #error_page  404              /404.html;

        # redirect server error pages to the static page /50x.html
        #
        error_page   500 502 503 504  /50x.html;
        location = /50x.html {
            root   html;
        }

        location /hls {
            # Serve HLS fragments
            types {
                application/vnd.apple.mpegurl m3u8;
                video/mp2t ts;
            }
            root ./temp;
            add_header Cache-Control no-cache;
        }
	}
}

rtmp {
    server {
        listen 1935;
        ping 30s;
        notify_method get;


        application hls {
            live on;

            # sample play/publish handlers
            #on_play http://localhost:8080/on_play;
            #on_publish http://localhost:8080/on_publish;

            # sample recorder
            #recorder rec1 {
            #    record all;
            #    record_interval 30s;
            #    record_path /tmp;
            #    record_unique on;
            #}

            # sample HLS
            hls on;
            hls_path ./temp/hls;
            hls_sync 1ms;
            hls_fragment 2s;
            #hls_max_fragment 1s;
            hls_playlist_length 4500ms;
        }
        
        application live {
        		live on;
               ### stream_buckets 1024;  ### limit n streams, but don't work ...
                        recorder rec1 {
               #record all manual;
               #record_suffix all.flv;
               #record_path ./temp/rec;
               #record_unique on;
           }
        }
        
        # Video on demand
        #application vod {
        #    play /var/Videos;
        #}

        # Video on demand over HTTP
        #application vod_http {
        #    play http://localhost:8080/vod/;
        #}
    }
}
